
<!DOCTYPE html>


<html lang="en" data-content_root="../../" >

  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" /><meta name="viewport" content="width=device-width, initial-scale=1" />

    <title>Why Aidge? &#8212; Eclipse Aidge  documentation</title>
  
  
  
  <script data-cfasync="false">
    document.documentElement.dataset.mode = localStorage.getItem("mode") || "";
    document.documentElement.dataset.theme = localStorage.getItem("theme") || "";
  </script>
  <!--
    this give us a css class that will be invisible only if js is disabled
  -->
  <noscript>
    <style>
      .pst-js-only { display: none !important; }

    </style>
  </noscript>
  
  <!-- Loaded before other Sphinx assets -->
  <link href="../../_static/styles/theme.css?digest=8878045cc6db502f8baf" rel="stylesheet" />
<link href="../../_static/styles/pydata-sphinx-theme.css?digest=8878045cc6db502f8baf" rel="stylesheet" />

    <link rel="stylesheet" type="text/css" href="../../_static/pygments.css?v=8f2a1f02" />
    <link rel="stylesheet" type="text/css" href="../../_static/graphviz.css?v=4ae1632d" />
    <link rel="stylesheet" type="text/css" href="../../_static/copybutton.css?v=76b2166b" />
    <link rel="stylesheet" type="text/css" href="../../_static/sg_gallery.css?v=d2d258e8" />
    <link rel="stylesheet" type="text/css" href="../../_static/sphinx-design.min.css?v=95c83b7e" />
    <link rel="stylesheet" type="text/css" href="../../_static/css/custom.css?v=794b2ffd" />
  
  <!-- So that users can add custom icons -->
  <script src="../../_static/scripts/fontawesome.js?digest=8878045cc6db502f8baf"></script>
  <!-- Pre-loaded scripts that we'll load fully later -->
  <link rel="preload" as="script" href="../../_static/scripts/bootstrap.js?digest=8878045cc6db502f8baf" />
<link rel="preload" as="script" href="../../_static/scripts/pydata-sphinx-theme.js?digest=8878045cc6db502f8baf" />

    <script src="../../_static/documentation_options.js?v=5929fcd5"></script>
    <script src="../../_static/doctools.js?v=9bcbadda"></script>
    <script src="../../_static/sphinx_highlight.js?v=dc90522c"></script>
    <script src="../../_static/clipboard.min.js?v=a7894cd8"></script>
    <script src="../../_static/copybutton.js?v=f281be69"></script>
    <script src="../../_static/design-tabs.js?v=f930bc37"></script>
    <script src="https://cdn.jsdelivr.net/npm/@jupyter-widgets/html-manager@^1.0.1/dist/embed-amd.js"></script>
    <script type="module" src="https://cdn.jsdelivr.net/npm/mermaid@10.3.0/dist/mermaid.esm.min.mjs"></script>
    <script type="module" src="https://cdn.jsdelivr.net/npm/@mermaid-js/layout-elk@0.1.4/dist/mermaid-layout-elk.esm.min.mjs"></script>
    <script type="module">import mermaid from "https://cdn.jsdelivr.net/npm/mermaid@10.3.0/dist/mermaid.esm.min.mjs";import elkLayouts from "https://cdn.jsdelivr.net/npm/@mermaid-js/layout-elk@0.1.4/dist/mermaid-layout-elk.esm.min.mjs";mermaid.registerLayoutLoaders(elkLayouts);mermaid.initialize({startOnLoad:false});</script>
    <script src="https://cdn.jsdelivr.net/npm/d3@7.9.0/dist/d3.min.js"></script>
    <script type="module">
import mermaid from "https://cdn.jsdelivr.net/npm/mermaid@10.3.0/dist/mermaid.esm.min.mjs";
window.addEventListener("load", () => mermaid.run());
</script>
    <script>DOCUMENTATION_OPTIONS.pagename = 'source/GetStarted/whyAidge';</script>
    <script>
        DOCUMENTATION_OPTIONS.theme_version = '0.16.1';
        DOCUMENTATION_OPTIONS.theme_switcher_json_url = 'https://eclipse-aidge.readthedocs.io/en/dev/_static/version_switcher.json';
        DOCUMENTATION_OPTIONS.theme_switcher_version_match = '0.5.0';
        DOCUMENTATION_OPTIONS.show_version_warning_banner =
            false;
        </script>
    <script src="../../_static/js/mermaid.min.js"></script>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="Quick Start" href="quickStart.html" />
    <link rel="prev" title="Install" href="install.html" />
  <meta name="viewport" content="width=device-width, initial-scale=1"/>
  <meta name="docsearch:language" content="en"/>
  <meta name="docsearch:version" content="0.5.0" />
  </head>
  
  
  <body data-bs-spy="scroll" data-bs-target=".bd-toc-nav" data-offset="180" data-bs-root-margin="0px 0px -60%" data-default-mode="">

  
  
  <div id="pst-skip-link" class="skip-link d-print-none"><a href="#main-content">Skip to main content</a></div>
  
  <div id="pst-scroll-pixel-helper"></div>
  
  <button type="button" class="btn rounded-pill" id="pst-back-to-top">
    <i class="fa-solid fa-arrow-up"></i>Back to top</button>

  
  <dialog id="pst-search-dialog">
    
<form class="bd-search d-flex align-items-center"
      action="../../search.html"
      method="get">
  <i class="fa-solid fa-magnifying-glass"></i>
  <input type="search"
         class="form-control"
         name="q"
         placeholder="Search the docs ..."
         aria-label="Search the docs ..."
         autocomplete="off"
         autocorrect="off"
         autocapitalize="off"
         spellcheck="false"/>
  <span class="search-button__kbd-shortcut"><kbd class="kbd-shortcut__modifier">Ctrl</kbd>+<kbd>K</kbd></span>
</form>
  </dialog>

  <div class="pst-async-banner-revealer d-none">
  <aside id="bd-header-version-warning" class="d-none d-print-none" aria-label="Version warning"></aside>
</div>

  
    <header class="bd-header navbar navbar-expand-lg bd-navbar d-print-none">
<div class="bd-header__inner bd-page-width">
  <button class="pst-navbar-icon sidebar-toggle primary-toggle" aria-label="Site navigation">
    <span class="fa-solid fa-bars"></span>
  </button>
  
  
  <div class="col-lg-3 navbar-header-items__start">
    
      <div class="navbar-item">

  
    
  

<a class="navbar-brand logo" href="../../index.html">
  
  
  
  
  
    
    
      
    
    
    <img src="../../_static/Isotype-aidge.png" class="logo__image only-light" alt=""/>
    <img src="../../_static/Isotype-aidge.png" class="logo__image only-dark pst-js-only" alt=""/>
  
  
    <p class="title logo__title">Eclipse Aidge</p>
  
</a></div>
    
      <div class="navbar-item">
<div class="version-switcher__container dropdown pst-js-only">
  <button id="pst-version-switcher-button-2"
    type="button"
    class="version-switcher__button btn btn-sm dropdown-toggle"
    data-bs-toggle="dropdown"
    aria-haspopup="listbox"
    aria-controls="pst-version-switcher-list-2"
    aria-label="Version switcher list"
  >
    Choose version  <!-- this text may get changed later by javascript -->
    <span class="caret"></span>
  </button>
  <div id="pst-version-switcher-list-2"
    class="version-switcher__menu dropdown-menu list-group-flush py-0"
    role="listbox" aria-labelledby="pst-version-switcher-button-2">
    <!-- dropdown will be populated by javascript on page load -->
  </div>
</div></div>
    
  </div>
  
  <div class="col-lg-9 navbar-header-items">
    
    <div class="me-auto navbar-header-items__center">
      
        <div class="navbar-item">
<nav>
  <ul class="bd-navbar-elements navbar-nav">
    
<li class="nav-item current active">
  <a class="nav-link nav-internal" href="index.html">
    Get Started
  </a>
</li>


<li class="nav-item ">
  <a class="nav-link nav-internal" href="../UserGuide/index.html">
    User Guide
  </a>
</li>


<li class="nav-item ">
  <a class="nav-link nav-internal" href="../Tutorial/index.html">
    Tutorials
  </a>
</li>


<li class="nav-item ">
  <a class="nav-link nav-internal" href="../API/index.html">
    API
  </a>
</li>

  </ul>
</nav></div>
      
    </div>
    
    
    <div class="navbar-header-items__end">
      
        <div class="navbar-item navbar-persistent--container">
          

<button class="btn search-button-field search-button__button pst-js-only" title="Search" aria-label="Search" data-bs-placement="bottom" data-bs-toggle="tooltip">
 <i class="fa-solid fa-magnifying-glass"></i>
 <span class="search-button__default-text">Search</span>
 <span class="search-button__kbd-shortcut"><kbd class="kbd-shortcut__modifier">Ctrl</kbd>+<kbd class="kbd-shortcut__modifier">K</kbd></span>
</button>
        </div>
      
      
        <div class="navbar-item">

<button class="btn btn-sm nav-link pst-navbar-icon theme-switch-button pst-js-only" aria-label="Color mode" data-bs-title="Color mode"  data-bs-placement="bottom" data-bs-toggle="tooltip">
  <i class="theme-switch fa-solid fa-sun                fa-lg" data-mode="light" title="Light"></i>
  <i class="theme-switch fa-solid fa-moon               fa-lg" data-mode="dark"  title="Dark"></i>
  <i class="theme-switch fa-solid fa-circle-half-stroke fa-lg" data-mode="auto"  title="System Settings"></i>
</button></div>
      
        <div class="navbar-item"><ul class="navbar-icon-links"
    aria-label="Icon Links">
        <li class="nav-item">
          
          
          
          
          
          
          
          
          <a href="<https://gitlab.eclipse.org/eclipse/aidge>" title="GitLab" class="nav-link pst-navbar-icon" rel="noopener" target="_blank" data-bs-toggle="tooltip" data-bs-placement="bottom"><i class="fab fa-gitlab fa-lg" aria-hidden="true"></i>
            <span class="sr-only">GitLab</span></a>
        </li>
</ul></div>
      
    </div>
    
  </div>
  
  
    <div class="navbar-persistent--mobile">

<button class="btn search-button-field search-button__button pst-js-only" title="Search" aria-label="Search" data-bs-placement="bottom" data-bs-toggle="tooltip">
 <i class="fa-solid fa-magnifying-glass"></i>
 <span class="search-button__default-text">Search</span>
 <span class="search-button__kbd-shortcut"><kbd class="kbd-shortcut__modifier">Ctrl</kbd>+<kbd class="kbd-shortcut__modifier">K</kbd></span>
</button>
    </div>
  

  
    <button class="pst-navbar-icon sidebar-toggle secondary-toggle" aria-label="On this page">
      <span class="fa-solid fa-outdent"></span>
    </button>
  
</div>

    </header>
  

  <div class="bd-container">
    <div class="bd-container__inner bd-page-width">
      
      
      
      <dialog id="pst-primary-sidebar-modal"></dialog>
      <div id="pst-primary-sidebar" class="bd-sidebar-primary bd-sidebar">
        

  
  <div class="sidebar-header-items sidebar-primary__section">
    
    
      <div class="sidebar-header-items__center">
        
          
          
            <div class="navbar-item">
<nav>
  <ul class="bd-navbar-elements navbar-nav">
    
<li class="nav-item current active">
  <a class="nav-link nav-internal" href="index.html">
    Get Started
  </a>
</li>


<li class="nav-item ">
  <a class="nav-link nav-internal" href="../UserGuide/index.html">
    User Guide
  </a>
</li>


<li class="nav-item ">
  <a class="nav-link nav-internal" href="../Tutorial/index.html">
    Tutorials
  </a>
</li>


<li class="nav-item ">
  <a class="nav-link nav-internal" href="../API/index.html">
    API
  </a>
</li>

  </ul>
</nav></div>
          
        
      </div>
    
    
    
      <div class="sidebar-header-items__end">
        
          <div class="navbar-item">

<button class="btn btn-sm nav-link pst-navbar-icon theme-switch-button pst-js-only" aria-label="Color mode" data-bs-title="Color mode"  data-bs-placement="bottom" data-bs-toggle="tooltip">
  <i class="theme-switch fa-solid fa-sun                fa-lg" data-mode="light" title="Light"></i>
  <i class="theme-switch fa-solid fa-moon               fa-lg" data-mode="dark"  title="Dark"></i>
  <i class="theme-switch fa-solid fa-circle-half-stroke fa-lg" data-mode="auto"  title="System Settings"></i>
</button></div>
        
          <div class="navbar-item"><ul class="navbar-icon-links"
    aria-label="Icon Links">
        <li class="nav-item">
          
          
          
          
          
          
          
          
          <a href="<https://gitlab.eclipse.org/eclipse/aidge>" title="GitLab" class="nav-link pst-navbar-icon" rel="noopener" target="_blank" data-bs-toggle="tooltip" data-bs-placement="bottom"><i class="fab fa-gitlab fa-lg" aria-hidden="true"></i>
            <span class="sr-only">GitLab</span></a>
        </li>
</ul></div>
        
      </div>
    
  </div>
  
    <div class="sidebar-primary-items__start sidebar-primary__section">
        <div class="sidebar-primary-item">
<nav class="bd-docs-nav bd-links"
     aria-label="Section Navigation">
  <p class="bd-links__title" role="heading" aria-level="1">Section Navigation</p>
  <div class="bd-toc-item navbar-nav"><ul class="current nav bd-sidenav">
<li class="toctree-l1"><a class="reference internal" href="install.html">Install</a></li>
<li class="toctree-l1 current active"><a class="current reference internal" href="#">Why Aidge?</a></li>
<li class="toctree-l1"><a class="reference internal" href="quickStart.html">Quick Start</a></li>
</ul>
</div>
</nav></div>
    </div>
  
  
  <div class="sidebar-primary-items__end sidebar-primary__section">
      <div class="sidebar-primary-item">
<div id="ethical-ad-placement"
      class="flat"
      data-ea-publisher="readthedocs"
      data-ea-type="readthedocs-sidebar"
      data-ea-manual="true">
</div></div>
  </div>


      </div>
      
      <main id="main-content" class="bd-main" role="main">
        
        
          <div class="bd-content">
            <div class="bd-article-container">
              
              <div class="bd-header-article d-print-none">
<div class="header-article-items header-article__inner">
  
    <div class="header-article-items__start">
      
        <div class="header-article-item">

<nav aria-label="Breadcrumb" class="d-print-none">
  <ul class="bd-breadcrumbs">
    
    <li class="breadcrumb-item breadcrumb-home">
      <a href="../../index.html" class="nav-link" aria-label="Home">
        <i class="fa-solid fa-home"></i>
      </a>
    </li>
    
    <li class="breadcrumb-item"><a href="index.html" class="nav-link">Get Started</a></li>
    
    <li class="breadcrumb-item active" aria-current="page"><span class="ellipsis">Why Aidge?</span></li>
  </ul>
</nav>
</div>
      
    </div>
  
  
</div>
</div>
              
              
              
                
<div id="searchbox"></div>
                <article class="bd-article">
                  
  <section id="why-aidge">
<h1>Why Aidge?<a class="headerlink" href="#why-aidge" title="Link to this heading">#</a></h1>
<p>Aidge is a generic, multi-paradigms compute graph manipulation, quantization, mapping, scheduling and code generation tool. Its primary targets are embedded systems with specialized hardware accelerators, especially dataflow or restricted instruction set architectures. It is highly interoperable thanks to built-in ONNX import/export and direct PyTorch interface, and its modularity allows to use any of its features in standalone or in conjunction with other tools along the deployment path of a model to the embedded system.</p>
<p>Please check below some reasons that might encourage you to use Aidge:</p>
<nav class="contents local" id="contents">
<ul class="simple">
<li><p><a class="reference internal" href="#well-defined-dataflow-graph-ir-model" id="id1">Well-defined dataflow graph IR model</a></p></li>
<li><p><a class="reference internal" href="#powerful-graph-search-replace-engine" id="id2">Powerful graph search &amp; replace engine</a></p></li>
<li><p><a class="reference internal" href="#generic-compiler-agnostic-tiling-methods" id="id3">Generic, compiler-agnostic tiling methods</a></p></li>
<li><p><a class="reference internal" href="#well-defined-consumer-producer-model-and-scheduling" id="id4">Well-defined consumer-producer model and scheduling</a></p></li>
<li><p><a class="reference internal" href="#generic-hardware-model-and-mapping-heuristics" id="id5">Generic hardware model and mapping heuristics</a></p></li>
<li><p><a class="reference internal" href="#simple-and-effective-code-generation-engine" id="id6">Simple and effective code generation engine</a></p></li>
<li><p><a class="reference internal" href="#seamless-interoperability-with-onnx-pytorch-and-tensorflow" id="id7">Seamless interoperability with ONNX, PyTorch and TensorFlow</a></p></li>
<li><p><a class="reference internal" href="#well-characterized-state-of-the-art-ptq-and-qat-methods" id="id8">Well-characterized, state-of-the-art PTQ and QAT methods</a></p></li>
</ul>
</nav>
<section id="well-defined-dataflow-graph-ir-model">
<h2><a class="toc-backref" href="#id1" role="doc-backlink">Well-defined dataflow graph IR model</a><a class="headerlink" href="#well-defined-dataflow-graph-ir-model" title="Link to this heading">#</a></h2>
<p>In Aidge, the computing graph is always explicitly specified by the user, who knows exactly which operators are instantiated. The notions of graph (a set of nodes), mathematical operator and actual implementation are separated: a node contains an operator, which itself points to an implementation. Furthermore, the graph only defines a topology, without any assumption on execution priority.</p>
<p>Here are some interesting Aidge features:</p>
<ul class="simple">
<li><p>A view can be created on any set or subset of nodes, which itself can constitute a (meta) node;</p></li>
<li><p>Graphs can be hierarchical (to any depth), thanks to meta operators that contain any graph view. It is trivial to (recursively) replace a set of nodes by a meta node or inversely, flatten a meta node to a set of nodes;</p></li>
<li><p>It is possible to specify any type of operator, even without a corresponding implementation, thanks to generic operators. No need to write a single line of code to handle custom operators at the graph level;</p></li>
<li><p>Nodes inputs and outputs are ordered, and any set of connected nodes can be ranked in a unique and deterministic way, making graph isomorphism identification trivial.</p></li>
<li><p>Cyclic graphs are supported. Unlike ONNX, any kind of graph can be fully flattened in Aidge and thus optimized globally.</p></li>
</ul>
<p>Below is an example of a cyclic graph (an LSTM) in Aidge:</p>
<pre align="center" class="mermaid align-center">
        flowchart TB
    FC_5(&quot;ltsm_inputGateH\n&lt;sub&gt;&lt;em&gt;(FC#5)&lt;/em&gt;&lt;/sub&gt;&quot;)
    Add_1(&quot;ltsm_inputGate\n&lt;sub&gt;&lt;em&gt;(Add#1)&lt;/em&gt;&lt;/sub&gt;&quot;)
    Sigmoid_1(&quot;ltsm_inputGateAct\n&lt;sub&gt;&lt;em&gt;(Sigmoid#1)&lt;/em&gt;&lt;/sub&gt;&quot;)
    Mul_1(&quot;ltsm_inputGateMul\n&lt;sub&gt;&lt;em&gt;(Mul#1)&lt;/em&gt;&lt;/sub&gt;&quot;)
    FC_2(&quot;ltsm_cellCandidateX\n&lt;sub&gt;&lt;em&gt;(FC#2)&lt;/em&gt;&lt;/sub&gt;&quot;)
    FC_6(&quot;ltsm_cellCandidateH\n&lt;sub&gt;&lt;em&gt;(FC#6)&lt;/em&gt;&lt;/sub&gt;&quot;)
    Add_2(&quot;ltsm_cellCandidate\n&lt;sub&gt;&lt;em&gt;(Add#2)&lt;/em&gt;&lt;/sub&gt;&quot;)
    Tanh_0(&quot;ltsm_cellCandidateAct\n&lt;sub&gt;&lt;em&gt;(Tanh#0)&lt;/em&gt;&lt;/sub&gt;&quot;)
    FC_3(&quot;ltsm_outputGateX\n&lt;sub&gt;&lt;em&gt;(FC#3)&lt;/em&gt;&lt;/sub&gt;&quot;)
    Mul_0(&quot;ltsm_forgetGateMul\n&lt;sub&gt;&lt;em&gt;(Mul#0)&lt;/em&gt;&lt;/sub&gt;&quot;)
    Sigmoid_0(&quot;ltsm_forgetGateAct\n&lt;sub&gt;&lt;em&gt;(Sigmoid#0)&lt;/em&gt;&lt;/sub&gt;&quot;)
    Add_0(&quot;ltsm_forgetGate\n&lt;sub&gt;&lt;em&gt;(Add#0)&lt;/em&gt;&lt;/sub&gt;&quot;)
    FC_4(&quot;ltsm_forgetGateH\n&lt;sub&gt;&lt;em&gt;(FC#4)&lt;/em&gt;&lt;/sub&gt;&quot;)
    FC_0(&quot;ltsm_forgetGateX\n&lt;sub&gt;&lt;em&gt;(FC#0)&lt;/em&gt;&lt;/sub&gt;&quot;)
    FC_7(&quot;ltsm_outputGateH\n&lt;sub&gt;&lt;em&gt;(FC#7)&lt;/em&gt;&lt;/sub&gt;&quot;)
    Add_3(&quot;ltsm_outputGate\n&lt;sub&gt;&lt;em&gt;(Add#3)&lt;/em&gt;&lt;/sub&gt;&quot;)
    Sigmoid_2(&quot;ltsm_outputGateAct\n&lt;sub&gt;&lt;em&gt;(Sigmoid#2)&lt;/em&gt;&lt;/sub&gt;&quot;)
    Mul_2(&quot;ltsm_outputGateMul\n&lt;sub&gt;&lt;em&gt;(Mul#2)&lt;/em&gt;&lt;/sub&gt;&quot;)
    Tanh_1(&quot;ltsm_cellUpdatedAct\n&lt;sub&gt;&lt;em&gt;(Tanh#1)&lt;/em&gt;&lt;/sub&gt;&quot;)
    FC_1(&quot;ltsm_inputGateX\n&lt;sub&gt;&lt;em&gt;(FC#1)&lt;/em&gt;&lt;/sub&gt;&quot;)
    Add_4(&quot;ltsm_add\n&lt;sub&gt;&lt;em&gt;(Add#4)&lt;/em&gt;&lt;/sub&gt;&quot;)
    Memorize_1(&quot;ltsm_cell_state\n&lt;sub&gt;&lt;em&gt;(Memorize#1)&lt;/em&gt;&lt;/sub&gt;&quot;)
    Memorize_0(&quot;ltsm_hidden_state\n&lt;sub&gt;&lt;em&gt;(Memorize#0)&lt;/em&gt;&lt;/sub&gt;&quot;)
    Identity_0(&quot;ltsm_input\n&lt;sub&gt;&lt;em&gt;(Identity#0)&lt;/em&gt;&lt;/sub&gt;&quot;)
    Pop_0(&lt;em&gt;Pop#0&lt;/em&gt;):::rootCls
    FC_5--&gt;|&quot;0&amp;rarr;1&quot;|Add_1
    Add_1--&gt;|&quot;0&amp;rarr;0&quot;|Sigmoid_1
    Sigmoid_1--&gt;|&quot;0&amp;rarr;0&quot;|Mul_1
    Mul_1--&gt;|&quot;0&amp;rarr;1&quot;|Add_4
    FC_2--&gt;|&quot;0&amp;rarr;0&quot;|Add_2
    FC_6--&gt;|&quot;0&amp;rarr;1&quot;|Add_2
    Add_2--&gt;|&quot;0&amp;rarr;0&quot;|Tanh_0
    Tanh_0--&gt;|&quot;0&amp;rarr;1&quot;|Mul_1
    FC_3--&gt;|&quot;0&amp;rarr;0&quot;|Add_3
    Mul_0--&gt;|&quot;0&amp;rarr;0&quot;|Add_4
    Sigmoid_0--&gt;|&quot;0&amp;rarr;0&quot;|Mul_0
    Add_0--&gt;|&quot;0&amp;rarr;0&quot;|Sigmoid_0
    FC_4--&gt;|&quot;0&amp;rarr;1&quot;|Add_0
    FC_0--&gt;|&quot;0&amp;rarr;0&quot;|Add_0
    FC_7--&gt;|&quot;0&amp;rarr;1&quot;|Add_3
    Add_3--&gt;|&quot;0&amp;rarr;0&quot;|Sigmoid_2
    Sigmoid_2--&gt;|&quot;0&amp;rarr;0&quot;|Mul_2
    Mul_2--&gt;|&quot;0&amp;rarr;0&quot;|Memorize_0
    Tanh_1--&gt;|&quot;0&amp;rarr;1&quot;|Mul_2
    FC_1--&gt;|&quot;0&amp;rarr;0&quot;|Add_1
    Add_4--&gt;|&quot;0&amp;rarr;0&quot;|Tanh_1
    Add_4--&gt;|&quot;0&amp;rarr;0&quot;|Memorize_1
    Memorize_1--&gt;|&quot;1&amp;rarr;1&quot;|Mul_0
    Memorize_0--&gt;|&quot;1&amp;rarr;0&quot;|FC_4
    Memorize_0--&gt;|&quot;1&amp;rarr;0&quot;|FC_5
    Memorize_0--&gt;|&quot;1&amp;rarr;0&quot;|FC_6
    Memorize_0--&gt;|&quot;1&amp;rarr;0&quot;|FC_7
    Identity_0--&gt;|&quot;0&amp;rarr;0&quot;|FC_0
    Identity_0--&gt;|&quot;0&amp;rarr;0&quot;|FC_1
    Identity_0--&gt;|&quot;0&amp;rarr;0&quot;|FC_2
    Identity_0--&gt;|&quot;0&amp;rarr;0&quot;|FC_3
    Pop_0--&gt;|&quot;0&amp;rarr;0&quot;|Identity_0
    input0((in#0)):::inputCls---&gt;|&quot;&amp;rarr;0&quot;|Pop_0
    input1((in#1)):::inputCls---&gt;|&quot;&amp;rarr;1&quot;|Memorize_0
    input2((in#2)):::inputCls---&gt;|&quot;&amp;rarr;1&quot;|Memorize_1
    Memorize_0---&gt;|&quot;0&amp;rarr;&quot;|output0((out#0)):::outputCls
    Memorize_1---&gt;|&quot;0&amp;rarr;&quot;|output1((out#1)):::outputCls
    classDef inputCls fill:#afa
    classDef outputCls fill:#ffa
    classDef externalCls fill:#ccc
    classDef producerCls fill:#ccf
    classDef genericCls fill:#f9f9ff,stroke-width:1px,stroke-dasharray: 5 5
    classDef metaCls stroke-width:5px
    classDef rootCls stroke:#f00
    classDef producerCls_rootCls stroke:#f00,fill:#ccf
    classDef genericCls_rootCls stroke:#f00,fill:#f9f9ff,stroke-width:1px,stroke-dasharray: 5 5
    classDef metaCls_rootCls stroke:#f00,stroke-width:5px
    </pre></section>
<section id="powerful-graph-search-replace-engine">
<h2><a class="toc-backref" href="#id2" role="doc-backlink">Powerful graph search &amp; replace engine</a><a class="headerlink" href="#powerful-graph-search-replace-engine" title="Link to this heading">#</a></h2>
<p>Aidge introduces a simple and efficient DSL for graph matching, sometimes called “graph regex”. It is possible to write complex textual queries to find a quantified or unquantified set of nodes with specific types, attributes and/or relationships between them. This is particularly useful to implement sophisticated pattern-matching heuristics with no effort!</p>
<p>Here is an example of a query that you can do in Aidge:</p>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="n">matches</span> <span class="o">=</span> <span class="n">aidge_core</span><span class="o">.</span><span class="n">SinglePassGraphMatching</span><span class="p">(</span><span class="n">model</span><span class="p">)</span><span class="o">.</span><span class="n">match</span><span class="p">(</span><span class="s2">&quot;(Pad#?-&gt;Conv#|Deconv#-&gt;Pad#?)-&gt;ReLU#?-&gt;Add#1?-&gt;ReLU#?-&gt;MaxPool#?-&gt;ReLU#?;.-&gt;Add#1?&quot;</span><span class="p">)</span>

<span class="k">for</span> <span class="n">match</span> <span class="ow">in</span> <span class="n">matches</span><span class="p">:</span>
    <span class="n">aidge_core</span><span class="o">.</span><span class="n">GraphView</span><span class="o">.</span><span class="n">replace</span><span class="p">(</span><span class="n">match</span><span class="p">,</span> <span class="n">MyCustomIPOperator</span><span class="p">())</span>
</pre></div>
</div>
<p>You can define your own node test function as well:</p>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="n">gm</span> <span class="o">=</span> <span class="n">aidge_core</span><span class="o">.</span><span class="n">SinglePassGraphMatching</span><span class="p">(</span><span class="n">model</span><span class="p">)</span>
<span class="n">gm</span><span class="o">.</span><span class="n">add_node_lambda</span><span class="p">(</span><span class="s2">&quot;test&quot;</span><span class="p">,</span> <span class="k">lambda</span> <span class="n">node</span><span class="p">:</span> <span class="o">...</span><span class="p">)</span>

<span class="n">matches</span> <span class="o">=</span> <span class="n">gm</span><span class="o">.</span><span class="n">match</span><span class="p">(</span><span class="s2">&quot;Conv-&gt;test&quot;</span><span class="p">)</span>
</pre></div>
</div>
<p>See the tutorial <a class="reference external" href="https://gitlab.eclipse.org/eclipse/aidge/aidge/-/blob/dev/examples/tutorials/GraphMatching/graph_matching.ipynb?ref_type=heads">Perform advanced graph matching with the Graph Matching tool</a> for more information.</p>
</section>
<section id="generic-compiler-agnostic-tiling-methods">
<h2><a class="toc-backref" href="#id3" role="doc-backlink">Generic, compiler-agnostic tiling methods</a><a class="headerlink" href="#generic-compiler-agnostic-tiling-methods" title="Link to this heading">#</a></h2>
<p>Operator tiling is an important operation in high-level compilers such as Halide or TVM, but usually implies an IR lowering step, such as C code generation, and a standard compiler backend, such as LLVM. In Aidge, tiling does not make any assumption on the programming paradigm. Thus, tiling is done at the same graph IR level, by just expanding the compute graph with tiled operators. It is up to the user to choose the right tiling granularity, depending on the type of operators he uses. The tiled operator implementation may be a C kernel, a call to a specific hardware accelerator or HLS-generated operator, or none of that, if the new tiled graph is just made to be exported back in ONNX, ready to be fed to another tool.</p>
<p>See the tutorial <a class="reference external" href="https://gitlab.eclipse.org/eclipse/aidge/aidge/-/blob/dev/examples/tutorials/Tiling_tutorial/tiling.ipynb?ref_type=heads">Optimize the inference of your neural network with Tiling</a> for more information.</p>
</section>
<section id="well-defined-consumer-producer-model-and-scheduling">
<h2><a class="toc-backref" href="#id4" role="doc-backlink">Well-defined consumer-producer model and scheduling</a><a class="headerlink" href="#well-defined-consumer-producer-model-and-scheduling" title="Link to this heading">#</a></h2>
<p>Aidge introduces a well-defined consumer-producer (C-P) model for operator implementations, similar to transaction-level modeling (TLM) for electronic design. A generic, default implementation is provided as well. C-P model can be specified as precise amounts of data or arbitrary data quantity (token), for each operator and dynamically at each execution step. The C-P model execution path is decoupled from the data execution path, thus allowing to statically schedule the graph execution without providing the actual operator’s implementation.</p>
<p>For example, for a 2D convolution implementation that only processes one input line at each execution step, it is trivial to build a pipelined dataflow and get the right execution order, by overloading two C-P methods in the implementation:</p>
<div class="highlight-c++ notranslate"><div class="highlight"><pre><span></span><span class="n">Elts_t</span><span class="w"> </span><span class="nf">MyCustomPipelinedConvImpl::getNbRequiredData</span><span class="p">(</span><span class="n">IOIndex_t</span><span class="w"> </span><span class="n">inputIdx</span><span class="p">)</span><span class="w"> </span><span class="p">{</span>
<span class="w">    </span><span class="c1">// Consume a single input line at each execution</span>
<span class="w">    </span><span class="k">return</span><span class="w"> </span><span class="n">Elts_t</span><span class="o">::</span><span class="n">DataElts</span><span class="p">(</span><span class="n">getInputLineSize</span><span class="p">(</span><span class="n">inputIdx</span><span class="p">));</span>
<span class="p">}</span>

<span class="n">Elts_t</span><span class="w"> </span><span class="nf">MyCustomPipelinedConvImpl::getRequiredMemory</span><span class="p">(</span><span class="n">IOIndex_t</span><span class="w"> </span><span class="n">outputIdx</span><span class="p">)</span><span class="w"> </span><span class="p">{</span>
<span class="w">    </span><span class="k">if</span><span class="w"> </span><span class="p">(</span><span class="n">enoughDataToComputeOutputLine</span><span class="p">())</span><span class="w"> </span><span class="p">{</span>
<span class="w">        </span><span class="c1">// Produce an output line only if there is enough input data</span>
<span class="w">        </span><span class="k">return</span><span class="w"> </span><span class="n">Elts_t</span><span class="o">::</span><span class="n">DataElts</span><span class="p">(</span><span class="n">getOutputLineSize</span><span class="p">(</span><span class="n">outputIdx</span><span class="p">));</span>
<span class="w">    </span><span class="p">}</span>
<span class="w">    </span><span class="k">else</span><span class="w"> </span><span class="p">{</span>
<span class="w">        </span><span class="k">return</span><span class="w"> </span><span class="n">Elts_t</span><span class="o">::</span><span class="n">DataElts</span><span class="p">(</span><span class="mi">0</span><span class="p">);</span>
<span class="w">    </span><span class="p">}</span>
<span class="p">}</span>
</pre></div>
</div>
<p>Thanks to Aidge’s C-P model, arbitrary complex cyclic and acyclic dataflow graphs can be statically scheduled. Generic sequential and parallel schedulers are available, and custom schedulers can be built using static scheduling data (logical early and late execution steps and associated dependencies for each scheduled node).</p>
</section>
<section id="generic-hardware-model-and-mapping-heuristics">
<h2><a class="toc-backref" href="#id5" role="doc-backlink">Generic hardware model and mapping heuristics</a><a class="headerlink" href="#generic-hardware-model-and-mapping-heuristics" title="Link to this heading">#</a></h2>
<p>🚧 This is planned for the next major Aidge release, stay tuned!</p>
</section>
<section id="simple-and-effective-code-generation-engine">
<h2><a class="toc-backref" href="#id6" role="doc-backlink">Simple and effective code generation engine</a><a class="headerlink" href="#simple-and-effective-code-generation-engine" title="Link to this heading">#</a></h2>
<p>Aidge uses the Jinja template engine to easily generate any type of code/programming model from a graph. It provides facilities to easily define what should be generated for each operator type. Beyond that, optimized static scheduling and memory mapping can be generated as well. Eventually, the full compute graph can be generated in an entirely static configuration, with minimal to no control overhead whatsoever during the execution of the dataflow on the intended hardware target, even in multi-threaded environments.</p>
<p>See the tutorial <a class="reference external" href="https://gitlab.eclipse.org/eclipse/aidge/aidge/-/blob/dev/examples/tutorials/Export_tutorial/add_custom_operator.ipynb?ref_type=heads">Add a custom implementation for a cpp export</a> for more information.</p>
</section>
<section id="seamless-interoperability-with-onnx-pytorch-and-tensorflow">
<h2><a class="toc-backref" href="#id7" role="doc-backlink">Seamless interoperability with ONNX, PyTorch and TensorFlow</a><a class="headerlink" href="#seamless-interoperability-with-onnx-pytorch-and-tensorflow" title="Link to this heading">#</a></h2>
<p>Aidge has native built-in ONNX import and export capabilities, even for custom ONNX operators.</p>
<p>🚧 As for now, Aidge only implements a restricted set of ONNX operators (unsupported operators are loaded as generic operators), but the list is growing! Advanced PyTorch and Tensorflow interoperability are planned for the next major Aidge release.</p>
</section>
<section id="well-characterized-state-of-the-art-ptq-and-qat-methods">
<h2><a class="toc-backref" href="#id8" role="doc-backlink">Well-characterized, state-of-the-art PTQ and QAT methods</a><a class="headerlink" href="#well-characterized-state-of-the-art-ptq-and-qat-methods" title="Link to this heading">#</a></h2>
<p>🚧 This is planned for the next major Aidge release, stay tuned!</p>
</section>
</section>


                </article>
              
              
              
              
              
                <footer class="prev-next-footer d-print-none">
                  
<div class="prev-next-area">
    <a class="left-prev"
       href="install.html"
       title="previous page">
      <i class="fa-solid fa-angle-left"></i>
      <div class="prev-next-info">
        <p class="prev-next-subtitle">previous</p>
        <p class="prev-next-title">Install</p>
      </div>
    </a>
    <a class="right-next"
       href="quickStart.html"
       title="next page">
      <div class="prev-next-info">
        <p class="prev-next-subtitle">next</p>
        <p class="prev-next-title">Quick Start</p>
      </div>
      <i class="fa-solid fa-angle-right"></i>
    </a>
</div>
                </footer>
              
            </div>
            
            
              
                <dialog id="pst-secondary-sidebar-modal"></dialog>
                <div id="pst-secondary-sidebar" class="bd-sidebar-secondary bd-toc"><div class="sidebar-secondary-items sidebar-secondary__inner">


  <div class="sidebar-secondary-item">
<div
    id="pst-page-navigation-heading-2"
    class="page-toc tocsection onthispage">
    <i class="fa-solid fa-list"></i> On this page
  </div>
  <nav class="bd-toc-nav page-toc" aria-labelledby="pst-page-navigation-heading-2">
    <ul class="visible nav section-nav flex-column">
<li class="toc-h2 nav-item toc-entry"><a class="reference internal nav-link" href="#well-defined-dataflow-graph-ir-model">Well-defined dataflow graph IR model</a></li>
<li class="toc-h2 nav-item toc-entry"><a class="reference internal nav-link" href="#powerful-graph-search-replace-engine">Powerful graph search &amp; replace engine</a></li>
<li class="toc-h2 nav-item toc-entry"><a class="reference internal nav-link" href="#generic-compiler-agnostic-tiling-methods">Generic, compiler-agnostic tiling methods</a></li>
<li class="toc-h2 nav-item toc-entry"><a class="reference internal nav-link" href="#well-defined-consumer-producer-model-and-scheduling">Well-defined consumer-producer model and scheduling</a></li>
<li class="toc-h2 nav-item toc-entry"><a class="reference internal nav-link" href="#generic-hardware-model-and-mapping-heuristics">Generic hardware model and mapping heuristics</a></li>
<li class="toc-h2 nav-item toc-entry"><a class="reference internal nav-link" href="#simple-and-effective-code-generation-engine">Simple and effective code generation engine</a></li>
<li class="toc-h2 nav-item toc-entry"><a class="reference internal nav-link" href="#seamless-interoperability-with-onnx-pytorch-and-tensorflow">Seamless interoperability with ONNX, PyTorch and TensorFlow</a></li>
<li class="toc-h2 nav-item toc-entry"><a class="reference internal nav-link" href="#well-characterized-state-of-the-art-ptq-and-qat-methods">Well-characterized, state-of-the-art PTQ and QAT methods</a></li>
</ul>
  </nav></div>

  <div class="sidebar-secondary-item">

  
  <div class="tocsection editthispage">
    <a href="https://gitlab.eclipse.org/eclipse/aidge/aidge/-/edit/master/docs/source/GetStarted/whyAidge.rst">
      <i class="fa-solid fa-pencil"></i>
      
      
        
          Edit on GitLab
        
      
    </a>
  </div>
</div>

  <div class="sidebar-secondary-item">
  <div role="note" aria-label="source link">
    <h3>This Page</h3>
    <ul class="this-page-menu">
      <li><a href="../../_sources/source/GetStarted/whyAidge.rst.txt"
            rel="nofollow">Show Source</a></li>
    </ul>
   </div></div>

</div></div>
              
            
          </div>
          <footer class="bd-footer-content">
            
          </footer>
        
      </main>
    </div>
  </div>
  
  <!-- Scripts loaded after <body> so the DOM is not blocked -->
  <script defer src="../../_static/scripts/bootstrap.js?digest=8878045cc6db502f8baf"></script>
<script defer src="../../_static/scripts/pydata-sphinx-theme.js?digest=8878045cc6db502f8baf"></script>

  <footer class="bd-footer">
<div class="bd-footer__inner bd-page-width">
  
    <div class="footer-items__start">
      
        <div class="footer-item">

  <p class="copyright">
    
      © Copyright 2023, CEA LIST.
      <br/>
    
  </p>
</div>
      
        <div class="footer-item">

  <p class="sphinx-version">
    Created using <a href="https://www.sphinx-doc.org/">Sphinx</a> 8.1.3.
    <br/>
  </p>
</div>
      
    </div>
  
  
  
    <div class="footer-items__end">
      
        <div class="footer-item">
<p class="theme-version">
  <!-- # L10n: Setting the PST URL as an argument as this does not need to be localized -->
  Built with the <a href="https://pydata-sphinx-theme.readthedocs.io/en/stable/index.html">PyData Sphinx Theme</a> 0.16.1.
</p></div>
      
    </div>
  
</div>

  </footer>
  </body>
</html>